(*
C U R T A I N                                               Hergestellt von der
                                                   KAP Dipl.-Ing. Holger Lembke
                                                           Hamburger Strae 284
                                                             38114 Braunschweig
                                                                        Germany

                                                        Telefon: +49-531-334676
                                                            Fax: +49-531-340215

0. Sorry
========
You might find some German words, funny english words or even complete
stupid sentences. Im sooo sorry. Please send me the correct version, if it
hurts too much.

1. What is Curtain
==================
You know the problem:

  procedure Tform.Button1Click(Sender: TObject);
  Var i : integer;
  begin
    for i:=1 to 1000 do begin             { loop }
      dosomething;
      application.processmessages;
    end;
  end;

During this loop, the user can still click on every tbutton, tlistbox,
tcheckbox etc. on the form. Focuses can be change, tcheckbox.checked will change,
all other clicks will be executed at the end of the loop.

Not very funny. The user gets puzzled, the program perhaps didnt work.

Just another problem:

  procedure Tform.Button1Click(Sender: TObject);
  Var i : integer;
  begin
    anotherform.show;                     {<------}
    for i:=1 to 1000 do begin             { loop }
      dosomething;
      application.processmessages;
    end;
    anotherform.hide;                     {<------}
  end;

Now you show a "please wait"-dialog. But it doesnt help! The user can switch back
to the form and press buttons, click in lists etc.

CURTAIN offers a very simple solution:

  It places a curtain over the form, that looks a bit like a greyed dialog.

So the user can see the dialog, he can click on it but nothing happens.

This is it. Not very much, but a great help. You will love it!

Usage is easy:

  procedure Tform.Button1Click(Sender: TObject);
  Var i : integer;
  begin
    addcurtaintoform(self);               {<=======}
    for i:=1 to 1000 do begin
      dosomething;
      application.processmessages;
    end;
    removecurtainfromform(self);          {<=======}
  end;

Or, if you like it as a TComponent, drop it into a form and use it like that:

  procedure Tform.Button1Click(Sender: TObject);
  Var i : integer;
  begin
    curtain1.onoff:=csclosed;             {<=======}
    for i:=1 to 1000 do begin
      dosomething;
      application.processmessages;
    end;
    curtain1.onoff:=csopen;               {<=======}
  end;


2. Using Curtain
================
YOU ARE NOT ALLOWED TO USE CURTAIN IN ANY COMMERCIAL PRODUKT WITHOUT BUYING IT.

Hereby you get the full source code. You can test it, see how it works, whether it
fits your demands.

You are allowed to use it for free products. But if Curtain is included in any
product you earn money with, you MUST buy it.
*)
unit Curtain;

interface

uses classes, forms;

(***********************************************************************************)
(***********************************************************************************)
Const  versionnumber = '1.0';

(***********************************************************************************)
(***********************************************************************************)
Type  curtainstate = (csopen, csclosed);

      TCurtain = class(TComponent)
         private
           fVersion   : string;
           fonoff     : curtainstate;
           procedure versionwrite(newversion : string);
           procedure curtainonoff(newstate : curtainstate);
         published
           constructor Create(AOwner: TComponent); override;
           property Version: string read fVersion write Versionwrite;
           property onoff : curtainstate read fonoff write curtainonoff;
       end;

(***********************************************************************************)
(***********************************************************************************)
procedure addcurtaintoform(form : tform);
procedure removecurtainfromform(form : tform);
(***********************************************************************************)
(***********************************************************************************)
procedure Register;
(***********************************************************************************)
(***********************************************************************************)

implementation

uses Controls, Extctrls, Graphics;

Const curtainobjectname = 'KAPCurtain';


(***********************************************************************************)
(***********************************************************************************)
(***********************************************************************************)
constructor TCurtain.Create(AOwner: TComponent);
begin
  fVersion:=versionnumber;
  inherited create(aowner);
end;

(***********************************************************************************)
procedure TCurtain.versionwrite(newversion : string);
begin
  fVersion:=versionnumber;
end;

(***********************************************************************************)
procedure TCurtain.curtainonoff(newstate : curtainstate);
begin
  if (newstate<>fonoff) then begin
    fonoff:=newstate;

    {dont close, if we are designing a form. Would work fine, but why?}
    if (componentstate*[csdesigning]<>[]) then exit;

    case newstate of
      csopen   : removecurtainfromform(tform(owner));
      csclosed : addcurtaintoform(tform(owner));
    end;
  end;
end;

(***********************************************************************************)
(***********************************************************************************)
procedure addcurtaintoform(form : tform);
Const ystepping = 2;
Var   wooopaah  : tpanel;
      image     : timage;
      color     : longint;
      i, ii,
      j, jj     : integer;
begin
  image:=timage.create(form);
  with image do begin
    width:=0;
    height:=0;
    align:=alclient;
    picture.bitmap.free;
    picture.bitmap:=form.getformimage;

    ii:=picture.bitmap.width;
    jj:=picture.bitmap.height;

    with picture.bitmap.canvas do begin
      pen.color:=form.color;
      pen.mode:=pmnotmerge;  {alle mglichen Zeichnstile ausprobieren}
      i:=0;
      repeat
        moveto(i,0);
        lineto(i,jj);
        inc(i,ystepping);
      until (i>ii);
    end;
  end;

  wooopaah:=tpanel.create(form);
  with wooopaah do begin
    name:=curtainobjectname;
    parent:=form;
    align:=alclient;
  end;

  image.parent:=wooopaah;
end;

(***********************************************************************************)
(***********************************************************************************)
procedure removecurtainfromform(form : tform);
Var i : integer;
begin
  i:=0;
  while (i<=pred(form.componentcount)) do begin
    if (form.components[i].name=curtainobjectname) then begin
      with form.components[i] as tpanel do begin
        controls[0].free;
        free;
      end;
      i:=form.componentcount;
    end;
    inc(i);
  end;
end;

(***********************************************************************************)
(***********************************************************************************)
procedure Register;
begin
  RegisterComponents('Holgis', [TCurtain]);
end;

end.

(*
3. Revisionsgeschichte

Version 1.01:  27.04.96
	- first release


A. Contacting the author

bussiness mail
CIS:       Holger Lembke [100112,3517]
Internet:  100112.3517@compuserve.com

privat mail
Internet:  holger_lembke@subtil.priconet.de
           holger_lembke@laguna.han.de
Fido:      Holger Lembke @ 2:241/1077.14

Phone:    +49-531-334676 GMT!!!!
FAX:      +49-531-340215


B. Ordering SHORTCUT EDITOR

  Absender:

	KAP Holger Lembke           .......................................,...............
	Hamburger Strae 284
	38114 Braunschweig          .......................................,...............
	Germany
                              .......................................,...............

	Fax: +49-531-340215         ......................................,................

                              .......................................,...............


	I order Curtain
	(This is a difficult orderform. Select the prices that language you talk at home.)

	( )   das Recht zur Nutzung incl. Updates           19,00 DM

	( )   the Right to Use including Updates          $ 13,00

	Germany only / Nur Deutschland
	( ) Die Summe ist als Scheck beigelegt.

	......................................................................................................
	(place, date, sign)

	Zahlung mit / Payment by
	( ) MASTER/EUROCARD        ( ) DINERS/VISA

	Card:         _______ - _______ - _______  - _______

	valid until:  _______ - _______

	......................................................................................................
	(place, date, extra-sign for creditcard-payment)

	(Only order with valid signs will be accepted,
	Nur Bestellungen mit Unterschrift werden akzeptiert.
  In allen Preisen sind 15% Mehrwertsteuer enthalten.


